//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link      "http://www.metaquotes.net"


//---Declaration--Flag Setting--- for Activation/Deactivation of pairs -----
//-------------------filter levels must be set for all pairs for code to be functional!---------(can go wide if no filter level is needed)

//========================================
// Constant Declarations
//========================================    

#define   NO_ENTRY      0    // I have declared some 'manifest constants' that will be useful for the entry rules. They are simply 'Word' substitutes
#define 	 LONG_ENTRY    1    // for the specified numbers.  They  make the program more readable.
#define   SHORT_ENTRY  -1    // Note that I have used all capital letters  for these constants to differentiate them from other other variables

                             //**** A thought! Would a manifest constant for the number of currency pairs simplify things a bit?

//+--------------------------------------------------------+
//|         EXTERNAL PARAMETERS                            |
//| can be set or adjusted by user in properties window    |
//+--------------------------------------------------------+ 
   
     //EURUSD parameters
     extern bool      EUR_USD_BuyFlag   = true;    //Set to true to allow long trading for this currency pair
     extern bool      EUR_USD_SellFlag = true;     //Set to true to allow short trading for this currency pair
     extern double    EUR_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for EURUSD
     extern double    EUR_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis EURUSD
     
     extern bool      GBP_USD_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      GBP_USD_SellFlag =  true;    //true = active, false= deactivated for trading
     extern double    GBP_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for GBPUSD
     extern double    GBP_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis GBPUSD
         
     extern bool      USD_JPY_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      USD_JPY_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_JPY_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDJPY
     extern double    USD_JPY_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDJPY
      
     extern bool      USD_CHF_BuyFlag   = true;    //true = active, false= deactivated for trading
     extern bool      USD_CHF_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_CHF_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDCHF
     extern double    USD_CHF_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDCHF
      
     extern bool      AUD_USD_BuyFlag   = true;     //true = active, false= deactivated for trading
     extern bool      AUD_USD_SellFlag  = true;     //true = active, false= deactivated for trading
     extern double    AUD_USD_TopFilter_Ok;         //Set the value of TopFilterLevel manually on a daily basis for AUDUSD
     extern double    AUD_USD_BotFilter_Ok;         //Set the value of BottomFilterLevel manually on a daily basis for AUDUSD

  
     extern double LotSize = 1.0 ;   // The default value is set to 1.0. The user can change it to whatever is required in the properties window.
     extern bool DEBUG_ON = true;   // This turns on the debug comments for testing and problem solving
     
   //*** The following line has been moved down a few lines to the global parameters area
   //*** This was done because it is not an external parameter. I'm just trying to keep things "neat and tidy :)"   
   //  string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"}; //***Global Declaration of Array 'Pair' so we can call it in 'start' function


//+------------------------------------------------------------------+
//| Global Parameters                                                |
//| These values can be read or changed from anywhere in this        |
//| program but not by the user from the properties box              |
//+------------------------------------------------------------------+

string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"}; //***Global Declaration of Array 'Pair' so we can call it in 'start' function
int TakeProfitStopSize = 20;   // TakeProfit Stop In pips. This can be made external if the user needs to change it. 
        

//+------------------------------------------------------------------+
//|                 INIT function                                    |
//| Expert initialization function                                   | 
//| This function is called once when the EA is attached to a chart  |
//| It can be used to initialise parameters etc                      |      
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//----
    
   if (DEBUG_ON)
      Print("*** Debug *** init()");
//----
   return(0);
  } // End of INIT function
  
  
//+------------------------------------------------------------------+
//|                 DEINIT function                                  |
//| Expert deinitialization function                                 | 
//| This function is called once when the EA is deleted from a chart |
//| It can be used to do clean ups such as closing files etc.        |      
//| It is often unused.                                              |
//+------------------------------------------------------------------+

int deinit()
  {
//----
   

   if (DEBUG_ON)
      Print("*** Debug *** deinit()");
 //----     
   return(0);
  } // End of DEINIT function
  
  
//+------------------------------------------------------------------+
//|                 START function                                   |
//| This is the main function that is called each 'tick' providing   |
//| the program isn't already busy. As this function is called,      |
//| typically  many times a minute we need to be carefull with what  |
//| we do here. It is quite easy to use up a lot of                  |
//| computer resources if we are not carefull.                       | 
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {
    string symbol;      //*** These items i.e. symbol and entrystatus, are called local variables. They are only valid inside the function in which 
    int  entryStatus;   //*** they are declared, unlike the global variables at the top of the program which can be accessed from anywhere in the program.
                        //*** Try to use local variables as much as possible as it keeps the program more modularised and helps prevent bugs
                        //*** Notice that I have started these local variable names with lower case letters. 
                        //*** This makes them more easily recognizable as local variables as compared to global variables whose names I start 
                        //*** with Upper Case letters. 
                        
   
           
    int count = ArraySize(CurrencyPair);        //computer doesn't know how many elements array has, this is necessary to set the value for 'for' loop
    for (int c=0;c<count;c++)                   //loop started to go through each element of the Array.
  
                                                //****  This will work but this array sizing only needs to be done once when the program starts up.
                                                //****  It is therefore better to place the array sizing into the init function and use it to set a
                                                //****  global parameter that we could call NumCurrencyPairs. Alternatively we could just use a fixed 5 
                                                //***   slot array and use a manifest constant to define it.
                                                //****  As it is not going to change in size a dynamic array is really overkill in this situation.
                                                //****  At the moment we are reinitializing the array every tick and this uses up unnecessary 
                                                //****  computer power. Too much inefficient coding can result in a slow running program which becomes 
                                                //****  particularly noticable when running optimizations. This is something that you must keep in
                                                //****  mind when writing larger or more complex programs.
                                        
                                            
   
                                                //After this I don't know how to use this, i guess we substitute OrderSend(Symbol)
                                                //part with the array name so it loops through that. is that so?        
                                              
    // *** Yes that is so and a bit more.  
    //*** I have added some curly brackets to the entire block so that the FOR LOOP now applies to the whole block i.e everything inside the curly brackets.                                             
    {
        symbol = CurrencyPair[c]; //*** For each iteration of this block we extract one currency pair from the array and assign it to the local variable named
                                  //*** symbol. Note that I have also changed the global array name Pair to CurrencyPair for what I thought was better readability.  
        
        //Check the Entry Rules block  to see if a BUY or SELL  condition exists for the allowed Currency Pairs 
        
        //*** TODO
        //*** First we will need to handle the top amd bottom filter levels for the  currency pairs
        //*** There is a number of ways of going about this. Perhaps the most straightforward is to use some more arrays and initialize them 
        //*** in the init function with the external parameter values. make sure you keep them all in the same order as the currency pair arrays   
        //*** and note that the first element in the array is [0] not [1]
        //*** You may as well set up the buy/sell flags in the same way while you are at it.
        
  
        //*** We now call the EntryRules fuction which at the moment is just an empty shell with some coments in it
        //*** We are going to pass some parameters to this function and  get it to return to us  one of three
        //*** possible values NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY
  
       
        entryStatus = EntryRules(); //*** TODO Pass this function some parameters between the brackets;
                                    //*** Make sure that the parameters are alos declared in the code for the function.

        //Check to see if  there is already  an open  BUY  position for this Currency Pair
        //Check to see if  there is already  an open SELL  position for this Currency Pair

        //If    there is no open BUY position  for this currency pair   AND
        //      a BUY condition exixts for this currency pair           AND
        //      the BuyFlag is set true for this currency pair
        //      THEN   
        //          Open a BUY Position  for this currency pair
	     //          USING  Last Ask Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount

        //If    there is no open SELL position  for this currency pair   AND
        //      a SELL condition exixts for this currency pair           AND
        //      the SellFlag is set true for this currency pair
        //      THEN   
        //          Open a SELL Position  for this currency pair
	     //          USING  Last Bid Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount

        //*** Finally I have updated our debug statement so that we can have a look and see what is happening
        if (DEBUG_ON)
            Print("*** Debug *** start() function",
                  "   symbol : ", symbol,
                  "   entryStatus : ", entryStatus);
  
    } // end of for loop for each currency pair

     

  } // End of START function
  
  

//+-------------------------------------------------------------------+
//|                 ENTRY RULES  function                             |
//| See if a BUY or SELL condition exists for a specified             |
//| currency pair                                                     |
//|                                                                   |
//+-------------------------------------------------------------------+
 
// void EntryRules()  //***  I changed the entry rules  from void - meaning nothing is returned by the function to int - meaning 
                      //***  the function returns an integer value.
                      //***  We want this function to return one of three possible values -  NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY
                      //***  These return values have been declared as manifest constants at the top of the program. 
                      //**** These constant declarations are global which means that they can be used anywhere in the program.
  
 //*** TODO - The code for this function                    
int EntryRules() // Parameter declarations for the function go between the brackets()
 {               // Parameters are declared the same way as variables. Multiple parameters should be separated by commas. 
                 // for example - int MyFunction(string MyText, int MyNumber, bool MyFlag)
 
 
// Local variable declarations go here! 
                    
 
 
                            //If   the 7 Period Exponential Moving Average is greater than the 14 Period Exponential Moving Average    AND
                            //     the 14 Period Exponential Moving Average is greater than the  50 period Simple Moving Average       AND
                            //     Current Price   is less than TopFilterLevel  
                            //     THEN
                            //          Signal a  BUY (Long) entry condition
		
      
                           //If   the  7 Period Exponential Moving Average is less than 14 Period Exponential Moving Average  AND
                           //     the 14 Period Exponential Moving Average is less than the 50 period Simple Moving Average     
                            //     Current Price   is more than  BottomFilterLevel  THEN
                            //     THEN
                            //          Signal a  SELL (Short) entry condition

  
    
      if (DEBUG_ON)
          Print("*** Debug *** EntryRules()");
 
    
      return(0); //*** Initially we assign a return value of 0 just to allow the program to compile.
                 //*** Eventually we will return a local variable which has been assigned a value of  NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY depending on the
                 //*** above logic
       
 }  // End of Entry Rules function


 
   
//------If (works) = celebrate !--------------------------------------------- 
   

//+------------------------------------------------------------------+